
_starting_LCD:

;Conversions.mbas,39 :: 		sub procedure starting_LCD()
;Conversions.mbas,40 :: 		Lcd_Init()              ' Initialize Lcd
	CALL        _Lcd_Init+0, 0
;Conversions.mbas,41 :: 		Lcd_Cmd(_LCD_CLEAR)            ' Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Conversions.mbas,42 :: 		Lcd_Cmd(_LCD_CURSOR_OFF)       ' Cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Conversions.mbas,43 :: 		Lcd_out(1,1,"Starting")
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       83
	MOVWF       ?LocalText_starting_LCD+0 
	MOVLW       116
	MOVWF       ?LocalText_starting_LCD+1 
	MOVLW       97
	MOVWF       ?LocalText_starting_LCD+2 
	MOVLW       114
	MOVWF       ?LocalText_starting_LCD+3 
	MOVLW       116
	MOVWF       ?LocalText_starting_LCD+4 
	MOVLW       105
	MOVWF       ?LocalText_starting_LCD+5 
	MOVLW       110
	MOVWF       ?LocalText_starting_LCD+6 
	MOVLW       103
	MOVWF       ?LocalText_starting_LCD+7 
	CLRF        ?LocalText_starting_LCD+8 
	MOVLW       ?LocalText_starting_LCD+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?LocalText_starting_LCD+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Conversions.mbas,44 :: 		Lcd_out(2,1,"Program")
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       80
	MOVWF       ?LocalText_starting_LCD+0 
	MOVLW       114
	MOVWF       ?LocalText_starting_LCD+1 
	MOVLW       111
	MOVWF       ?LocalText_starting_LCD+2 
	MOVLW       103
	MOVWF       ?LocalText_starting_LCD+3 
	MOVLW       114
	MOVWF       ?LocalText_starting_LCD+4 
	MOVLW       97
	MOVWF       ?LocalText_starting_LCD+5 
	MOVLW       109
	MOVWF       ?LocalText_starting_LCD+6 
	CLRF        ?LocalText_starting_LCD+7 
	MOVLW       ?LocalText_starting_LCD+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?LocalText_starting_LCD+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Conversions.mbas,45 :: 		delay_mS(500)
	MOVLW       6
	MOVWF       R11, 0
	MOVLW       19
	MOVWF       R12, 0
	MOVLW       173
	MOVWF       R13, 0
L__starting_LCD1:
	DECFSZ      R13, 1, 1
	BRA         L__starting_LCD1
	DECFSZ      R12, 1, 1
	BRA         L__starting_LCD1
	DECFSZ      R11, 1, 1
	BRA         L__starting_LCD1
	NOP
	NOP
;Conversions.mbas,46 :: 		Lcd_Cmd(_LCD_CLEAR)            ' Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Conversions.mbas,47 :: 		if (uart1_tx_idle = 1) then
	CALL        _UART1_TX_Idle+0, 0
	MOVF        R0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__starting_LCD3
;Conversions.mbas,48 :: 		uart1_write_Text("Starting Program" + CRLF + CRLF)
	MOVLW       83
	MOVWF       ?LocalText_starting_LCD+0 
	MOVLW       116
	MOVWF       ?LocalText_starting_LCD+1 
	MOVLW       97
	MOVWF       ?LocalText_starting_LCD+2 
	MOVLW       114
	MOVWF       ?LocalText_starting_LCD+3 
	MOVLW       116
	MOVWF       ?LocalText_starting_LCD+4 
	MOVLW       105
	MOVWF       ?LocalText_starting_LCD+5 
	MOVLW       110
	MOVWF       ?LocalText_starting_LCD+6 
	MOVLW       103
	MOVWF       ?LocalText_starting_LCD+7 
	MOVLW       32
	MOVWF       ?LocalText_starting_LCD+8 
	MOVLW       80
	MOVWF       ?LocalText_starting_LCD+9 
	MOVLW       114
	MOVWF       ?LocalText_starting_LCD+10 
	MOVLW       111
	MOVWF       ?LocalText_starting_LCD+11 
	MOVLW       103
	MOVWF       ?LocalText_starting_LCD+12 
	MOVLW       114
	MOVWF       ?LocalText_starting_LCD+13 
	MOVLW       97
	MOVWF       ?LocalText_starting_LCD+14 
	MOVLW       109
	MOVWF       ?LocalText_starting_LCD+15 
	MOVLW       13
	MOVWF       ?LocalText_starting_LCD+16 
	MOVLW       10
	MOVWF       ?LocalText_starting_LCD+17 
	MOVLW       13
	MOVWF       ?LocalText_starting_LCD+18 
	MOVLW       10
	MOVWF       ?LocalText_starting_LCD+19 
	MOVLW       0
	MOVWF       ?LocalText_starting_LCD+20 
	MOVLW       ?LocalText_starting_LCD+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?LocalText_starting_LCD+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
L__starting_LCD3:
;Conversions.mbas,50 :: 		end sub
L_end_starting_LCD:
	RETURN      0
; end of _starting_LCD

_convert:

;Conversions.mbas,60 :: 		dim intxt as string[6] nval,fwval as word fval as float
;Conversions.mbas,61 :: 		if inval.15 then            'negative value
	BTFSS       FARG_convert_inval+1, 7 
	GOTO        L__convert7
;Conversions.mbas,62 :: 		nval = not(inval)        'complement it 1 = 0, 0 = 1
	COMF        FARG_convert_inval+0, 0 
	MOVWF       convert_nval+0 
	COMF        FARG_convert_inval+1, 0 
	MOVWF       convert_nval+1 
;Conversions.mbas,63 :: 		nval = nval + 1          'convert to normal word
	INFSNZ      convert_nval+0, 1 
	INCF        convert_nval+1, 1 
;Conversions.mbas,64 :: 		nflag = true             'tells us it's negative
	BSF         _flag+0, 0 
	GOTO        L__convert8
;Conversions.mbas,65 :: 		else
L__convert7:
;Conversions.mbas,66 :: 		nval = inval
	MOVF        FARG_convert_inval+0, 0 
	MOVWF       convert_nval+0 
	MOVF        FARG_convert_inval+1, 0 
	MOVWF       convert_nval+1 
;Conversions.mbas,67 :: 		nflag = false            'not negative so inval is used
	BCF         _flag+0, 0 
;Conversions.mbas,68 :: 		end if
L__convert8:
;Conversions.mbas,69 :: 		wordtohex(inval,intxt)      'gives 2 bytes  for info only
	MOVF        FARG_convert_inval+0, 0 
	MOVWF       FARG_WordToHex_input+0 
	MOVF        FARG_convert_inval+1, 0 
	MOVWF       FARG_WordToHex_input+1 
	MOVLW       convert_intxt+0
	MOVWF       FARG_WordToHex_output+0 
	MOVLW       hi_addr(convert_intxt+0)
	MOVWF       FARG_WordToHex_output+1 
	CALL        _WordToHex+0, 0
;Conversions.mbas,70 :: 		wordtohex(nval,msg1)
	MOVF        convert_nval+0, 0 
	MOVWF       FARG_WordToHex_input+0 
	MOVF        convert_nval+1, 0 
	MOVWF       FARG_WordToHex_input+1 
	MOVLW       _msg1+0
	MOVWF       FARG_WordToHex_output+0 
	MOVLW       hi_addr(_msg1+0)
	MOVWF       FARG_WordToHex_output+1 
	CALL        _WordToHex+0, 0
;Conversions.mbas,71 :: 		ltrim(msg1)
	MOVLW       _msg1+0
	MOVWF       FARG_ltrim_astring+0 
	MOVLW       hi_addr(_msg1+0)
	MOVWF       FARG_ltrim_astring+1 
	CALL        _ltrim+0, 0
;Conversions.mbas,76 :: 		fwval = nval>>4      'lowest value for TCN75 is .0625 degree  (2^-4)
	MOVF        convert_nval+0, 0 
	MOVWF       R0 
	MOVF        convert_nval+1, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
;Conversions.mbas,77 :: 		fval = fwval * res   'allows selection of diffrent resolutions, should  match settings for TCN75 config reg
	CALL        _Word2Double+0, 0
	MOVF        FARG_convert_res+0, 0 
	MOVWF       R4 
	MOVF        FARG_convert_res+1, 0 
	MOVWF       R5 
	MOVF        FARG_convert_res+2, 0 
	MOVWF       R6 
	MOVF        FARG_convert_res+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
;Conversions.mbas,78 :: 		floattostr(fval,fltxt)
	MOVF        R0, 0 
	MOVWF       FARG_FloatToStr_input+0 
	MOVF        R1, 0 
	MOVWF       FARG_FloatToStr_input+1 
	MOVF        R2, 0 
	MOVWF       FARG_FloatToStr_input+2 
	MOVF        R3, 0 
	MOVWF       FARG_FloatToStr_input+3 
	MOVLW       _fltxt+0
	MOVWF       FARG_FloatToStr_output+0 
	MOVLW       hi_addr(_fltxt+0)
	MOVWF       FARG_FloatToStr_output+1 
	CALL        _FloatToStr+0, 0
;Conversions.mbas,79 :: 		if nflag then
	BTFSS       _flag+0, 0 
	GOTO        L__convert10
;Conversions.mbas,80 :: 		strappendpre("-",fltxt)
	MOVLW       45
	MOVWF       FARG_strAppendPre_letter+0 
	MOVLW       _fltxt+0
	MOVWF       FARG_strAppendPre_s1+0 
	MOVLW       hi_addr(_fltxt+0)
	MOVWF       FARG_strAppendPre_s1+1 
	CALL        _strAppendPre+0, 0
L__convert10:
;Conversions.mbas,83 :: 		Uart1_write_text("Inval = 0X" + intxt +  " Nval = " + msg1 +" Value =  " + fltxt + CRLF)
	MOVLW       _???addstrings_temp_convert+0
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(_???addstrings_temp_convert+0)
	MOVWF       FSR1L+1 
	MOVLW       73
	MOVWF       POSTINC1+0 
	MOVLW       110
	MOVWF       POSTINC1+0 
	MOVLW       118
	MOVWF       POSTINC1+0 
	MOVLW       97
	MOVWF       POSTINC1+0 
	MOVLW       108
	MOVWF       POSTINC1+0 
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       61
	MOVWF       POSTINC1+0 
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       48
	MOVWF       POSTINC1+0 
	MOVLW       88
	MOVWF       POSTINC1+0 
	MOVLW       convert_intxt+0
	MOVWF       FSR2L+0 
	MOVLW       hi_addr(convert_intxt+0)
	MOVWF       FSR2L+1 
	CALL        ___CS2S+0, 0
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       78
	MOVWF       POSTINC1+0 
	MOVLW       118
	MOVWF       POSTINC1+0 
	MOVLW       97
	MOVWF       POSTINC1+0 
	MOVLW       108
	MOVWF       POSTINC1+0 
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       61
	MOVWF       POSTINC1+0 
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       _msg1+0
	MOVWF       FSR2L+0 
	MOVLW       hi_addr(_msg1+0)
	MOVWF       FSR2L+1 
	CALL        ___CS2S+0, 0
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       86
	MOVWF       POSTINC1+0 
	MOVLW       97
	MOVWF       POSTINC1+0 
	MOVLW       108
	MOVWF       POSTINC1+0 
	MOVLW       117
	MOVWF       POSTINC1+0 
	MOVLW       101
	MOVWF       POSTINC1+0 
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       61
	MOVWF       POSTINC1+0 
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       32
	MOVWF       POSTINC1+0 
	MOVLW       _fltxt+0
	MOVWF       FSR2L+0 
	MOVLW       hi_addr(_fltxt+0)
	MOVWF       FSR2L+1 
	CALL        ___CS2S+0, 0
	MOVLW       _CRLF+0
	MOVWF       TBLPTRL+0 
	MOVLW       hi_addr(_CRLF+0)
	MOVWF       TBLPTRL+1 
	MOVLW       higher_addr(_CRLF+0)
	MOVWF       TBLPTRL+2 
	CALL        ___CCS2S+0, 0
	CLRF        POSTINC1+0 
	MOVLW       _???addstrings_temp_convert+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_???addstrings_temp_convert+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Conversions.mbas,84 :: 		end sub
L_end_convert:
	RETURN      0
; end of _convert

_main:

;Conversions.mbas,86 :: 		main:
;Conversions.mbas,88 :: 		OSCCON = 0x60
	MOVLW       96
	MOVWF       OSCCON+0 
;Conversions.mbas,89 :: 		ANSELA = 0             ' Configure PORTA pins as digital
	CLRF        ANSELA+0 
;Conversions.mbas,90 :: 		ANSELB = 0             ' Configure PORTB pins as digital
	CLRF        ANSELB+0 
;Conversions.mbas,91 :: 		ANSELC = 0             ' Configure PORTC pins as digital
	CLRF        ANSELC+0 
;Conversions.mbas,93 :: 		ANSELD = 0          ' Configure PORTD pins as digital
	CLRF        ANSELD+0 
;Conversions.mbas,94 :: 		LATD = 0
	CLRF        LATD+0 
;Conversions.mbas,95 :: 		portd = 0
	CLRF        PORTD+0 
;Conversions.mbas,96 :: 		TRISD = 0
	CLRF        TRISD+0 
;Conversions.mbas,99 :: 		portb = 0
	CLRF        PORTB+0 
;Conversions.mbas,100 :: 		LATB = 0                ' Clear PORTB
	CLRF        LATB+0 
;Conversions.mbas,101 :: 		TRISB = 0x00
	CLRF        TRISB+0 
;Conversions.mbas,105 :: 		portc = 0x60            'need to force bit 6 high to avoid 0xff as first char on uart
	MOVLW       96
	MOVWF       PORTC+0 
;Conversions.mbas,106 :: 		Latc = 0
	CLRF        LATC+0 
;Conversions.mbas,107 :: 		TrisC = 0x98            'I2C on RC 3(SCL) & 4(SDA), UART1 TX on 6, RX on 7
	MOVLW       152
	MOVWF       TRISC+0 
;Conversions.mbas,109 :: 		Uart1_init(9600)        'start uart1
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       207
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;Conversions.mbas,110 :: 		delay_mS(250)           'let it all settle down
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L__main13:
	DECFSZ      R13, 1, 1
	BRA         L__main13
	DECFSZ      R12, 1, 1
	BRA         L__main13
	DECFSZ      R11, 1, 1
	BRA         L__main13
	NOP
	NOP
;Conversions.mbas,111 :: 		starting_LCD()          'start LCD
	CALL        _starting_LCD+0, 0
;Conversions.mbas,119 :: 		neword = inbH1           'get hi byte of value
	MOVLW       255
	MOVWF       _neword+0 
	MOVLW       0
	MOVWF       _neword+1 
;Conversions.mbas,120 :: 		neword = neword<<8      'move to hi byte of word note: not signed value just word(unsigned integer)
	MOVF        _neword+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        R0, 0 
	MOVWF       _neword+0 
	MOVF        R1, 0 
	MOVWF       _neword+1 
;Conversions.mbas,121 :: 		neword = neword + inbL1
	MOVLW       229
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _neword+0 
	MOVF        R1, 0 
	MOVWF       _neword+1 
;Conversions.mbas,122 :: 		convert(neword,res4)    'neword is now the whole value in 2s compliment of the TCN75 read value.
	MOVF        R0, 0 
	MOVWF       FARG_convert_inval+0 
	MOVF        R1, 0 
	MOVWF       FARG_convert_inval+1 
	MOVLW       0
	MOVWF       FARG_convert_res+0 
	MOVLW       0
	MOVWF       FARG_convert_res+1 
	MOVLW       0
	MOVWF       FARG_convert_res+2 
	MOVLW       126
	MOVWF       FARG_convert_res+3 
	CALL        _convert+0, 0
;Conversions.mbas,125 :: 		neword = inbH2           'get hi byte of value
	MOVLW       2
	MOVWF       _neword+0 
	MOVLW       0
	MOVWF       _neword+1 
;Conversions.mbas,126 :: 		neword = neword<<8      'move to hi byte of word note: not signed value just word(unsigned integer)
	MOVF        _neword+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        R0, 0 
	MOVWF       _neword+0 
	MOVF        R1, 0 
	MOVWF       _neword+1 
;Conversions.mbas,127 :: 		neword = neword + inbL2
	MOVLW       37
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _neword+0 
	MOVF        R1, 0 
	MOVWF       _neword+1 
;Conversions.mbas,128 :: 		convert(neword,res4)    'neword is now the whole value in 2s compliment of the TCN75 read value.
	MOVF        R0, 0 
	MOVWF       FARG_convert_inval+0 
	MOVF        R1, 0 
	MOVWF       FARG_convert_inval+1 
	MOVLW       0
	MOVWF       FARG_convert_res+0 
	MOVLW       0
	MOVWF       FARG_convert_res+1 
	MOVLW       0
	MOVWF       FARG_convert_res+2 
	MOVLW       126
	MOVWF       FARG_convert_res+3 
	CALL        _convert+0, 0
;Conversions.mbas,130 :: 		neword = inbH3           'get hi byte of value
	MOVLW       247
	MOVWF       _neword+0 
	MOVLW       0
	MOVWF       _neword+1 
;Conversions.mbas,131 :: 		neword = neword<<8       'move to hi byte of word note: not signed value just word(unsigned integer)
	MOVF        _neword+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        R0, 0 
	MOVWF       _neword+0 
	MOVF        R1, 0 
	MOVWF       _neword+1 
;Conversions.mbas,132 :: 		neword = neword + inbL3
	MOVLW       69
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _neword+0 
	MOVF        R1, 0 
	MOVWF       _neword+1 
;Conversions.mbas,133 :: 		convert(neword,res4)    'neword is now the whole value in 2s compliment of the TCN75 read value.
	MOVF        R0, 0 
	MOVWF       FARG_convert_inval+0 
	MOVF        R1, 0 
	MOVWF       FARG_convert_inval+1 
	MOVLW       0
	MOVWF       FARG_convert_res+0 
	MOVLW       0
	MOVWF       FARG_convert_res+1 
	MOVLW       0
	MOVWF       FARG_convert_res+2 
	MOVLW       126
	MOVWF       FARG_convert_res+3 
	CALL        _convert+0, 0
;Conversions.mbas,135 :: 		neword = inbH4           'get hi byte of value
	CLRF        _neword+0 
	CLRF        _neword+1 
;Conversions.mbas,136 :: 		neword = neword<<8      'move to hi byte of word note: not signed value just word(unsigned integer)
	MOVF        _neword+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        R0, 0 
	MOVWF       _neword+0 
	MOVF        R1, 0 
	MOVWF       _neword+1 
;Conversions.mbas,137 :: 		neword = neword + inbL4
	MOVLW       21
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _neword+0 
	MOVF        R1, 0 
	MOVWF       _neword+1 
;Conversions.mbas,138 :: 		convert(neword,res4)    'neword is now the whole value in 2s compliment of the TCN75 read value.
	MOVF        R0, 0 
	MOVWF       FARG_convert_inval+0 
	MOVF        R1, 0 
	MOVWF       FARG_convert_inval+1 
	MOVLW       0
	MOVWF       FARG_convert_res+0 
	MOVLW       0
	MOVWF       FARG_convert_res+1 
	MOVLW       0
	MOVWF       FARG_convert_res+2 
	MOVLW       126
	MOVWF       FARG_convert_res+3 
	CALL        _convert+0, 0
;Conversions.mbas,140 :: 		while true
L__main15:
;Conversions.mbas,141 :: 		Latd.1 = not latd.1           'rest of program goes here
	BTG         LATD+0, 1 
;Conversions.mbas,142 :: 		delay_mS(250)
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L__main19:
	DECFSZ      R13, 1, 1
	BRA         L__main19
	DECFSZ      R12, 1, 1
	BRA         L__main19
	DECFSZ      R11, 1, 1
	BRA         L__main19
	NOP
	NOP
;Conversions.mbas,143 :: 		wend
	GOTO        L__main15
L_end_main:
	GOTO        $+0
; end of _main
